module pixgen #(
    parameter integer X_DEPTH   = 9,
    parameter integer Y_DEPTH   = 9,
    parameter integer RGB_DEPTH = 24
) (
    input clk,
    input start,
    input [X_DEPTH-1:0] x,
    input [Y_DEPTH-1:0] y,
    output reg [RGB_DEPTH-1:0] rgb,
    output reg done
);

// given x and y inputs, create an rgb output

always @(posedge clk) begin
  if (start) begin
    done <= 1;
    rgb <= { x[8:0], y[8:0] };
  end
  else done <= 0;
end

endmodule
